#ifndef KNOB_FILE_H
#define KNOB_FILE_H

#include <stdint.h>

struct file;

struct file *open_file(const char *path);
void close_file(struct file *f);

uint32_t read_from_file(struct file *f, uint32_t max, void *buf);
uint32_t seek_file_to(struct file *f, uint32_t to);
int32_t seek_file_by(struct file *f, int32_t by);

uint32_t file_size(struct file *f) __attribute__ ((pure));

#endif