#include "vga.h"
#include "serial.h"

#define INFO_COM COM1

void init_log() {
  vga_set_color(0x30);
  vga_blank();
}

void logch(char ch) {
  if (ch == '\n') {
    sout(INFO_COM, (uint8_t)'\r');
    sout(INFO_COM, (uint8_t)'\n');
  }
  else
    sout(INFO_COM, (uint8_t)ch);

  vga_printch(ch);
}

void logsz(const char *sz) {
  while (*sz)
    logch(*sz++);
}