#include "panic.h"
#include "log.h"
#include "vga.h"

void panic(const char *message) {
  vga_set_color(0x4f);
  vga_blank();
  logsz("Kernel panic: ");
  logsz(message);
  logsz("\nHalting.");
  while (1)
    asm volatile ("hlt");
}