#include <stdbool.h>
#include <stdint.h>

bool try_sntoi(const char *s, uint32_t n, uint32_t *out) {
  uint32_t calc = 0;
  for (uint32_t i = 0; i < n; ++i) {
    if ((s[i] < '0') || (s[i] > '9'))
      return false;
    calc = calc * 10 + s[i] - '0';
  }
  *out = calc;
  return true;
}